#ifndef __FP_MATH_HEAD
#define __FP_MATH_HEAD
extern double ceil(double x);
extern double floor(double x);
extern double fabs(double x);
extern double exp(double x);
extern double ldexp(double x, int n);
extern double frexp(double x, int *exp);
extern double modf(double x, double *ip);
extern double fmod(double x, double y);
extern double log(double x);
extern double log10(double x);
extern double pow(double x, double y);
extern double sqrt(double x);
extern double sin(double theta);
extern double asin(double x);
extern double sinh(double theta);
extern double cos(double theta);
extern double acos(double x);
extern double cosh(double theta);
extern double tan(double theta);
extern double atan(double x);
extern double atan2(double y, double x);
extern double tanh(double theta);

/* Useful constants.  */

#ifndef MAXFLOAT
#define MAXFLOAT    3.40282347e+38F
#endif

#ifndef M_E
#define M_E         2.7182818284590452354
#endif

#ifndef M_LOG2E
#define M_LOG2E     1.4426950408889634074
#endif

#ifndef M_LOG10E
#define M_LOG10E    0.43429448190325182765
#endif

#ifndef M_LN2
#define M_LN2       0.69314718055994530942
#endif

#ifndef M_LN10
#define M_LN10      2.30258509299404568402
#endif

#ifndef M_PI
#define M_PI        3.14159265358979323846
#endif

#ifndef M_TWOPI
#define M_TWOPI     (M_PI * 2.0)
#endif

#ifndef M_PI_2
#define M_PI_2      1.57079632679489661923
#endif

#ifndef M_PI_4
#define M_PI_4      0.78539816339744830962
#endif

#ifndef M_3PI_4
#define M_3PI_4     2.3561944901923448370E0
#endif

#ifndef M_SQRTPI
#define M_SQRTPI    1.77245385090551602792981
#endif

#ifndef M_1_PI
#define M_1_PI      0.31830988618379067154
#endif

#ifndef M_2_PI
#define M_2_PI      0.63661977236758134308
#endif

#ifndef M_2_SQRTPI
#define M_2_SQRTPI  1.12837916709551257390
#endif

#ifndef M_SQRT2
#define M_SQRT2     1.41421356237309504880
#endif

#ifndef M_SQRT1_2
#define M_SQRT1_2   0.70710678118654752440
#endif

#ifndef M_LN2LO
#define M_LN2LO     1.9082149292705877000E-10
#endif

#ifndef M_LN2HI
#define M_LN2HI     6.9314718036912381649E-1
#endif

#ifndef M_SQRT3
#define M_SQRT3     1.73205080756887719000
#endif

#ifndef M_IVLN10
#define M_IVLN10    0.43429448190325182765 /* 1 / log(10) */
#endif

#ifndef M_LOG2_E
#define M_LOG2_E    0.693147180559945309417
#endif

#ifndef M_INVLN2
#define M_INVLN2    1.4426950408889633870E0  /* 1 / log(2) */
#endif


#endif
